/**
 * generated by Xtext 2.15.0
 */
package org.xtext.ungs.drake.tests;

import com.google.inject.Inject;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.testing.InjectWith;
import org.eclipse.xtext.testing.XtextRunner;
import org.eclipse.xtext.testing.util.ParseHelper;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.xtext.ungs.drake.drake.Model;
import org.xtext.ungs.drake.tests.DrakeInjectorProvider;

@RunWith(XtextRunner.class)
@InjectWith(DrakeInjectorProvider.class)
@SuppressWarnings("all")
public class DrakeParsingTest {
  @Inject
  private ParseHelper<Model> parserHelper;
  
  @Test
  public void parseValidModel1() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("min x_{1} * 10 + 20 st y >= 10, x_{1} <= 100");
      final Model result = this.parserHelper.parse(_builder);
      Assert.assertNotNull(result);
      Assert.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseValidModel2() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("max x_{1,3} * 10 st y = 10, x_{1} <= 10");
      final Model result = this.parserHelper.parse(_builder);
      Assert.assertNotNull(result);
      Assert.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseValidSets() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("set vacio := {}");
      _builder.newLine();
      _builder.append("set tuplaVacia := {<>,<>}");
      _builder.newLine();
      _builder.append("set x := {<1>, <3>, <2>}");
      _builder.newLine();
      _builder.append("set y := {<4,1>, <2,1>}");
      _builder.newLine();
      _builder.append("set z := {<hola>, <\"hola\">, <12, x_{12, 12}>}");
      _builder.newLine();
      _builder.append("set tuplaTupla := {<<<<>>>>}");
      _builder.newLine();
      _builder.append("set I := {1 to 3}");
      _builder.newLine();
      _builder.append("max x * 10 st y = 10, y <= 10");
      _builder.newLine();
      final Model result = this.parserHelper.parse(_builder);
      Assert.assertNotNull(result);
      Assert.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  @Test
  public void parseSummation() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("set I := {1 to 3}");
      _builder.newLine();
      _builder.append("min x_{1} * 10 + x st y = 10, x_{1} <= 10");
      final Model result = this.parserHelper.parse(_builder);
      Assert.assertNotNull(result);
      Assert.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  /**
   * Test con ejemplo concreto de modelado de problema de coloreo de gráfo.
   * Se utilizan las variables Xj con j perteneciente al conjunto de colores.
   * Además, se utiliza Xij con j perteneciente al conjunto de colores e i
   * perteneciente al conjunto de vértices
   * 
   * w_1 + w_2 + w_3 + w_4 <= 1 es la función objetivo.
   * 
   * sum x_{i,j} <= 1 para todo i para todo j intenta asegurarse de que se
   * utilice solo un color para cada nodo
   */
  @Test
  public void parseExample() {
    try {
      StringConcatenation _builder = new StringConcatenation();
      _builder.append("min w_1 + w_2 + w_3 + w_4 st ");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1,1} + x_{1,2} + x_{1,3} + x_{1,4} <= 1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2,1} + x_{2,2} + x_{2,3} + x_{2,4} <= 1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{3,1} + x_{3,2} + x_{3,3} + x_{3,4} <= 1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{4,1} + x_{4,2} + x_{4,3} + x_{4,4} <= 1, ");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 1} + x_{2,1} <= w_1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 2} + x_{2,2} <= w_2,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 3} + x_{2,3} <= w_3,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 4} + x_{2,4} <= w_4,");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 1} + x_{4,1} <= w_1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 2} + x_{4,2} <= w_2,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 3} + x_{4,3} <= w_3,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{1, 4} + x_{4,4} <= w_4,");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 1} + x_{4,1} <= w_1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 2} + x_{4,2} <= w_2,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 3} + x_{4,3} <= w_3,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 4} + x_{4,4} <= w_4,");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 1} + x_{3,1} <= w_1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 2} + x_{3,2} <= w_2,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 3} + x_{3,3} <= w_3,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{2, 4} + x_{3,4} <= w_4,");
      _builder.newLine();
      _builder.append("\t");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{3, 1} + x_{4,1} <= w_1,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{3, 2} + x_{4,2} <= w_2,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{3, 3} + x_{4,3} <= w_3,");
      _builder.newLine();
      _builder.append("\t");
      _builder.append("x_{3, 4} + x_{4,4} <= w_4");
      _builder.newLine();
      final Model result = this.parserHelper.parse(_builder);
      Assert.assertNotNull(result);
      Assert.assertTrue(result.eResource().getErrors().isEmpty());
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
